<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <title>PHP5 Spidering by Google Blogoscoped</title>
    <link rel="stylesheet" href="default.css" type="text/css" media="screen, projection" />
</head>
<body>

<?

$g_spiderCount = 0;
$g_spiderMax = 1000;
$g_spiderFirstMax = 3;
$g_urlsDone = '';
$g_maxLevel = 3;

spiderUrl('http://blog.outer-court.com');

function spiderUrl($url, $level = 0)
{
    global $g_spiderCount;
    global $g_spiderMax;
    global $g_maxLevel;

    $g_spiderCount++;

    if (! ($g_spiderCount > $g_spiderMax || $level > $g_maxLevel) )
    {
        $dom = new domdocument;
        @$dom->loadHTMLFile($url);
    
        $xpath = new domxpath($dom);
    
        echo '<ul>';
        $xNodes = @$xpath->query('//body//a[@href]');
        $linkCount = 0;
        foreach ($xNodes as $xNode)
        {
            handleLink(&$xNode, $level, $url, &$linkCount);
        }
        echo '</ul>';
    }
}

?>

</body>
</html><?

function handleLink(&$xNode, $level, $url, &$linkCount)
{
    global $g_spiderFirstMax;

    $subtype = @$xNode->firstChild->nodeName;
    $sLinkcontent = '';
    if ($subtype == 'img')
    {
        $sLinkcontent = @$xNode->firstChild->getAttribute('alt');
    }
    else if ($subtype == '#text')
    {
        $sLinkcontent = @$xNode->firstChild->data;
    }

    $sLinkurl = $xNode->getAttribute('href');
    if ( $sLinkcontent != '' && $sLinkurl != ''
            && stripos($sLinkurl, 'javascript:') === false
            && stripos($sLinkurl, 'ftp://') === false
            && stripos($sLinkurl, 'mailto:') === false )
    {
        $fullhref = getAbsoluteUrl($url, $sLinkurl);

        if ( !getUrlWasSpidered($fullhref) )
        {
            if (++$linkCount <= $g_spiderFirstMax)
            {
                $linkdisplay = str_replace('http://', '', $fullhref);
                $linkdisplay = reduce($linkdisplay);

                echo '<li>';
                echo ' <a href="' . $fullhref . '">' .
                        htmlentities($sLinkcontent) . '</a><br />';
                echo '<span class="url">' . $linkdisplay . '</span><br />';
                spiderUrl($fullhref, $level + 1);
                echo '</li>';
            }
        }
    }
}

function getUrlWasSpidered($fullhref)
{
    global $g_urlsDone;

    $sCheck = '[[' . $fullhref . ']]';
    $urlWasSpidered = ! (stripos($g_urlsDone, $sCheck) === false);
    if (!$urlWasSpidered)
    {
        $g_urlsDone .= $sCheck;
    }

    return $urlWasSpidered;
}

function getAbsoluteUrl($absolute, $relative)
{
    if (preg_match(',^(https?://|ftp://|mailto:|news:),i', $relative))
        return $relative;

    $url = parse_url($absolute);
    
    if (@$url['path']{strlen(@$url['path']) - 1} == '/')
        $dir = substr(@$url['path'], 0, strlen(@$url['path']) - 1);
    else
        $dir = dirname(@$url['path']);

    if ($relative{0} == '/') {
        $relative = substr($relative, 1);
        $dir = '';
    }
    elseif (substr($relative, 0, 2) == './')
        $relative = substr($relative, 2);
    else while (substr($relative, 0, 3) == '../') {
        $relative = substr($relative, 3);
        $dir = substr($dir, 0, strrpos($dir, '/'));
    }

    return sprintf('%s://%s%s/%s', $url['scheme'], $url['host'], $dir, $relative);
}

function reduce($url, $length = 50)
{
    $x = substr($url, 0, $length);
    if ( strlen($url) > $length + 7 )
    {
        $x .= ' ...';
    }
    return $x;
}

?>